library volume;
{ Gladiators Software, 1999-2006}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}
{$IMAGEBASE $00400000}

{$r Bmp.res}

uses
  Windows,
  messages,
  ShellAPI,
  FNxxx in '..\SDK\FNxxx.pas',
  AstonSDK in '..\SDK\AstonSDK.pas',
  st_api in '..\SDK\st_api.pas',
  Drawpng in '..\SDK\Drawpng.pas',
  AstonEx in '..\SDK\AstonEx.pas';
const
 szName:Pchar = 'Test plug-in';
 szhelp:Pchar = 'Test plug-in';
 szSection:Pchar = 'Test_PLG';
 szXY = 'XY';
 szXYHint = 'Coordinates';
 szZOrderHint = 'Z-Order';
 szZOrder = 'ZOrder';
 szSkin = 'Skin';
 szScrollbar = 'Scrollbar';
 szSlider = 'Slider';
 szScrollbarPos = 'ScrollbarPos';
 szsetupplg = 'Setup plug-in';


 TPos = 2;
 TPosT:array[0..TPos] of PChar=('Desktop','Normal','Always on top');

 KeyCount = 8;
 Keys:array[1..KeyCount] of TKey = (
  (szKey:nil; nType:KEY_TAB; szHint:'General';    vDefault: 0; res1:0; res2:0),
  (szKey: szXY; nType:KEY_POINT; szHint: szXYHint;
       vDefault: 0; res1:0; res2:0),
  (szKey: szZOrder; nType:KEY_LIST; szHint: szZOrderHint;
       vDefault: 1; res1:TPos; res2:0),
  (szKey:nil; nType:KEY_TAB; szHint:'Skin';    vDefault: 0; res1:0; res2:0),
  (szKey: szSkin; nType:KEY_PICTURE; szHint: szSkin;
       vDefault: 0; res1:0; res2:0),
  (szKey: szScrollbar; nType:KEY_PICTURE; szHint: szScrollbar;
       vDefault: 0; res1:0; res2:0),
  (szKey: szSlider; nType:KEY_PICTURE; szHint: szSlider;
       vDefault: 0; res1:0; res2:0),
  (szKey: szScrollbarPos; nType:KEY_POINT; szHint: szScrollbarPos;
       vDefault: 0; res1:0; res2:0)

  );

var
  PluginInfo:TPluginInfo;
  AData: TAstonData;
  ii:pointer;
  btn, index,j,k,s,b:integer;
  pp:Ppaint;
  CFG:TCFG;
  xy:TPoint;
  ZOrder:integer;
  bgskin_path,
  sbar_path,
  slider_path:array[0..max_path]of CHAR;
  scroll_pos:Tpoint;
//---------------------------------------------------------------------
procedure LoadConfig();   // read Config
begin
  OpenCFGr(AData.PluginsCFG, @CFG);
  FindSection(szSection, 0, @CFG);
  xy.x := 50; // default coordinates
  xy.y := 50;
  GetCFGPoint(szXY,  xy, @CFG);
  scroll_pos.x := 30;
  scroll_pos.y := 12;
  GetCFGPoint(szScrollbarPos,  scroll_pos, @CFG);
  ZOrder := GetCFGInt(szZOrder, 2, @CFG);
  GetCFGString(szSkin, #0, bgskin_path, max_path, @CFG);
  GetCFGString(szScrollbar, #0, sbar_path, max_path, @CFG);
  GetCFGString(szSlider, #0, slider_path, max_path, @CFG);
  CloseCFGr(@CFG);
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
procedure ShowError(text:Pchar);
begin
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);   // disable recycle
  MessageBox(0, text, 'Error', MB_ICONWARNING or MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);   // enable recycle
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
function WindowProc(Window: HWnd; Msg:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
 st:array[0..max_path]of CHAR;
 r:TRECT;
 CFG:TCFG;
 i:integer;
 p:TPoint;
 Menu:HMENU;
begin
 result := 0; // default result =  0 !!!!
    case Msg of
WM_EXITSIZEMOVE: // finish window dragging and save window position
      begin
          GetWindowRect(window, r);
          RtlZeroMemory(@CFG, sizeof(TCFG));
          OpenCFGw(AData.PluginsCFG, @CFG);
          FindSection(szSection, 1, @CFG);
          p.x := r.left;
          p.y := r.top;
          SetCFGPoint(szXY, p, @CFG);
          CloseCFGw(AData.PluginsCFG, false, @CFG);
          result := 1;
      end;

WM_RBUTTONDOWN:
    begin
      result := 1;
    end;

WM_CONTEXTMENU,
WM_RBUTTONUP:
    begin
      Menu:=CreatePopupMenu();
      AppendMenu(Menu,  MF_ENABLED or MF_STRING, 10, szsetupplg);
      GetCursorPos(p);
      SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);
      TrackPopupMenuEx(Menu, 0, p.X, p.Y, Window, nil);
      SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);
      DestroyMenu(Menu);
      result := 1;
    end;

WM_COMMAND:
  begin
     case LoWord(wParam) of
      10: begin
             st[0]:='/';
             strcopy(@st[1], AData.Node.Path);
             SendMessage(AData.MainWindow, CM_SETUPASTON, 0,
                         longint(@st[0]));
           end;
     end;
     result := 1;
  end;
WM_LBUTTONDOWN:  // wParam - layer index
        begin
            if wParam = btn then
            begin
              //...
            end;
        end;

WM_HSCROLL: // WParam = scrollbar position, LParam - scroll index
        // show scrollbar position
        begin
          // SET VOLUME HERE!!!
          
          wvsprintf(st, '%i', @WParam);
          SetRect(r,0,0,100,100);
          pp := AstonWND(ii).LayerPaint_Begin(j);
          AstonWND(ii).DrawText(pp.dc, st, @r, GetStockObject(SYSTEM_FONT), DT_LEFT, $0000ff, true, 0);
          AstonWND(ii).LayerPaint_End(pp);
          AstonWND(ii).RedRaw();
          result := 1;
        end;

    end;

end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
 path:array[0..max_path]of char;
 p:PPaint;
 r:Trect;
 vol:integer;
 pic:Tpicture;
 flag:integer;
begin

  if AstonData.cbsize<SizeOf(TAstonData) then exit;
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  LoadConfig();

  if (ZOrder=0) then flag := AWS_FADESTYLE or AWS_LAYERED or AWS_DRAWWALLPAPER
  else flag := AWS_FADESTYLE or AWS_LAYERED;

  ii:= pointer(CreateAstonWND(xy.x,xy.y, AData.Desktop, ZOrder, flag, @WindowProc, AData.Desktop, 10));   // create window
  if (ii = nil) then
  begin
   ShowError('Aston window dont create');
   exit;
  end;
  if (AstonWND(ii).GetVer <19200) then   // check version
  begin
    ShowError('Old version AstonEx.dll Please update Aston');
    DestroyWindow(AstonWND(ii).wnd()); //  destroy window
    ii := nil;
    exit;
  end;

  RtlZeroMemory(@pic, sizeof(TPicture));
  pic.IconType := PICTURE_BMP;
  index := AstonWND(ii).SetBG(bgskin_path); // add  background (zero layer)
  if (index<0) then
  begin
    index := AstonWND(ii).CreateCustomLayer(0, 0,0, 180, 30, LAYER_DRAG, 0);
    if (index>=0) then
    begin
      p := AstonWND(ii).LayerPaint_Begin(index);
      setrect(r, 0,0, p.size.cx, p.size.cy);
      FillRect(p.dc, r, GetStockObject(BLACK_BRUSH));
      pic.Handle:= LoadImage(HInstance, Pchar(101), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
      pic.Width :=180;
      pic.Height :=30;
      DrawPicture(p.dc, p.dc, 0,0, @pic);
      DeleteObject(pic.Handle);



      AstonWND(ii).LayerPaint_End(p);
    end;  
  end;
  if (index<0) then exit;

  //---------------------------------------------------------------

 //---------------------------------------------------------------
  s := AstonWND(ii).AddLayer(0,scroll_pos.x, scroll_pos.y, sbar_path, LAYER_DRAG, 0);
  if (s<0) then
  begin
    s := AstonWND(ii).CreateCustomLayer(0, scroll_pos.x, scroll_pos.y, 108, 2, 0, 0);
    if (s>=0) then
    begin
      p := AstonWND(ii).LayerPaint_Begin(s);
      setrect(r, 0,0, p.size.cx, p.size.cy);
      FillRect(p.dc, r, GetStockObject(BLACK_BRUSH));
      pic.Handle:= LoadImage(HInstance, Pchar(102), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
      pic.Width :=108;
      pic.Height :=2;
      DrawPicture(p.dc, p.dc, 0,0, @pic);
      DeleteObject(pic.Handle);
      AstonWND(ii).LayerPaint_End(p);
    end;
  end;
  if (s<0) then exit;

  b := AstonWND(ii).AddLayer(0,0,0,slider_path, 0, 0);

  if (b<0) then
  begin
    b := AstonWND(ii).CreateCustomLayer(0, 0,0, 14, 13, 0, 0);
    if (b>=0) then
    begin
      p := AstonWND(ii).LayerPaint_Begin(b);
      setrect(r, 0,0, p.size.cx, p.size.cy);
      FillRect(p.dc, r, GetStockObject(BLACK_BRUSH));
      pic.Handle:= LoadImage(HInstance, Pchar(103), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
      pic.Width :=14;
      pic.Height :=13;
      DrawPicture(p.dc, p.dc, 0,0, @pic);
      DeleteObject(pic.Handle);
      AstonWND(ii).LayerPaint_End(p);
    end;
  end;
  if (b<0) then exit;

  vol := 50; // default volume
  AstonWND(ii).MakeScrollBar(s,b,0, 100, vol,0);  // min=0% max=100% def=50%

  j := AstonWND(ii).CreateCustomLayer(0, 145,5, 30,20, LAYER_DRAG or LAYER_LAYERED,0);  // layer for drawing scrollbar position

  SendMessage(AstonWND(ii).wnd, WM_HSCROLL, vol, j);
 //---------------------------------------------------------------

  AstonWND(ii).Show(1);
end;
//---------------------------------------------------------------------

procedure DoneModule;stdcall;
begin
 DestroyWindow(AstonWND(ii).wnd); // free all layers
end;
//---------------------------------------------------------------------

function GetPluginInfo():PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szSection;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  Keys[3].res2:=integer(@TPosT);
  result:= @PluginInfo;
end; 

exports
  InitGlobalModule,
  GetPluginInfo,
  DoneModule;
end.
