library ChngWall;

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\..\plg.pas}
{$ENDIF}

uses
 Windows,
 Messages,
 ShellAPI,
 FNxxx in '..\..\SDK\FNxxx.pas',
 AstonSDK in '..\..\SDK\AstonSDK.pas',
 st_api in '..\..\SDK\st_api.pas';

{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
const
 Name: array[0..22]of Char = 'Wallpaper Changer'#0;
 Dsk:PChar = 'Wallpaper Changer 1.5'#13#10+
 ' 1999-2006 Gladiators Software';

 DateFormat:PChar = 'MMdd';

 szControl_Panel_desktop:PChar='Control Panel\desktop';

 szWallpaper:PChar='Wallpaper';
 szTileWallpaper:PChar='TileWallpaper';
 szWallpaperStyle:PChar='WallpaperStyle';

 szDate = 'Temp';
 szChange = 'Change';
 szChangeHint = 'Change wallpaper';
 cSchedule = 2;
 vSchedule:array[0..cSchedule] of PChar=('each logon','each day (after logon or recycle)',{'each hour',}'each recycle (but not from A-Master)');
 szMethod = 'Method';
 cMethods = 2;
 vMethods:array[0..cMethods] of PChar=('random','circle (down)','circle (up)');


 KeyCount = 2;
 WallKeys:array[1..KeyCount] of TKey = (
 (szKey:szChange; nType:KEY_LIST or KEY_NOTHEME;  szHint: szChangeHint;
      vDefault: 0;       res1:cSchedule; res2:0),
 (szKey:szMethod; nType:KEY_LIST or KEY_NOTHEME;  szHint: szMethod;
      vDefault: 0;       res1:cMethods; res2:0)
      );

var
 AData: TAstonData;
 PluginInfo:TPluginInfo;
 Method,
  Schedule: integer;
 Seed: integer;
 AName: ATOM;
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
function Randu(Range: integer): integer;
asm
{     ->EAX     Range   }
{     <-EAX     Result  }
        IMUL    EDX,Seed,08088405H
        INC     EDX
        MOV     Seed,EDX
        MUL     EDX
        MOV     EAX,EDX
end;
{----------------------------------------------------------------}
{----------------------------------------------------------------}
procedure SetRegInt(Key:HKEY; szValue:PChar; Value: integer);
var
  st:array[0..31] of char;
  DataSize,DataType:integer;
begin
  if Key=0 then exit;
  DataSize := wvsprintf(st, '%i', @Value);
  inc(DataSize);
  DataType := REG_SZ;
  RegSetValueEx(Key, szValue, 0,  DataType,
               @st[0], DataSize);
end;
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
procedure ChangeWallpaperNow;
var
 CFG:TCFG;
 Wallpapers: PNodelist;
 t, i, Current, WallMax, WallCount: integer;
 tmp1, tmp2: array[0..max_path] of Char;
 WallTile, WallStyle: integer;
 phk: HKEY;
begin
 OpenCFGw(AData.PluginsCFG, @CFG);
 if FindSection(szWallpaper, 0, @CFG)<>0 then
 begin
  PDWORD(@tmp1[0])^:=0;
  if AData.Ring1.WallPaper<>nil then
   GetShortPathName(AData.Ring1.WallPaper, tmp1, max_path);
  WallMax:=128;
  WallCount:=0;
  Wallpapers:=nil;
  GetNodeList(Wallpapers, WallCount, WallMax);
  if WallCount<2 then
  begin
   CloseCFGw(AData.PluginsCFG, false, @CFG);
   exit;{NO CHOOSE!}
  end;
  Current:=0;
  if PDWORD(@tmp1[0])^<>0 then
   for i:=1 to WallCount do
   begin
    PDWORD(@tmp2[0])^:=0;
    GetShortPathName(Wallpapers[i].Glyph.FileName, tmp2, max_path);
    if lstrcmpi(tmp1, tmp2)=0 then
    begin
     Current:= i;
     break;
    end;
   end;{endif}

  case Method of
   0:
   begin
    repeat
     i:= Randu(WallCount)+1;
    until i<>Current;
    Current:= i;
   end;
   1:
   begin{circle down}
    if Current >= WallCount then Current:= 0;
    inc(Current);
   end;
   else
   begin{circle up}
    dec(Current);
    if Current <= 0 then Current:= WallCount;
   end;
  end;{case}

  t:= Wallpapers[Current].NodeType;
  if t=0 then t:=2;
  t:= t and 3;
  dec(t);
  WallTile:=0;
  WallStyle:=0;
  if t=1 then WallTile:=1
         else WallStyle:=t;
  if RegOpenKeyEx(HKEY(HKEY_CURRENT_USER),
             szControl_Panel_desktop,  0, KEY_WRITE, phk)<>ERROR_SUCCESS then phk:=0;
  SetRegInt(phk, szTileWallpaper, WallTile);
  SetRegInt(phk, szWallpaperStyle, WallStyle);
  if phk<>0 then RegCloseKey(phk);

  FindSection(@Name[0], SECTION_CREATE_ALWAYS, @CFG);


  if GetDateFormat(LOCALE_SYSTEM_DEFAULT,
                   0, nil, DateFormat, tmp1, max_path)<>0 then
   SetCFGString(szDate, tmp1, @CFG);

  CloseCFGw(AData.PluginsCFG, false, @CFG);

  OpenCFGw(AData.AstonCFG, @CFG);
  CFG.Section:=CFG.Text;
  PDWORD(@tmp1[0])^:=0;
  lstrcpy(tmp1, Wallpapers[Current].Glyph.FileName);
  SetCFGString(szWallpaper, tmp1, @CFG);
  CloseCFGw(AData.AstonCFG, false, @CFG);

  SendMessage(AData.MainWindow, CM_WALLPAPER, 0, 0);

  FreeNodeList(Wallpapers, WallCount, WallMax);
 end
  else
  CloseCFGw(AData.PluginsCFG, false, @CFG);
end;

{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
procedure ReadConfig;
var
 CFG:TCFG;
 logon: boolean;
 Date, NewDate: array[0..7] of char;
begin
 OpenCFGr(AData.PluginsCFG, @CFG);
 FindSection(@Name[0], 0, @CFG);
 Schedule:= GetCFGInt(szChange, 0, @CFG);
 CheckInt(Schedule, 0, cSchedule, 0);
 Method:= GetCFGInt(szMethod, 0, @CFG);
 CheckInt(Method, 0, cMethods, 0);


 GetCFGString(szDate, '', Date, sizeof(Date), @CFG);

 CloseCFGr(@CFG);
 logon:=SendMessage(Adata.MainWindow, CM_GETPLUGINMEMSIZE,
          0, longint(@Name[0]))<>sizeOf(Name)+1;
 if logon then
 begin
    SendMessage(Adata.MainWindow, CM_SAVEPLUGINMEM, sizeOf(Name)+1, longint(@Name[0]));
 end
    else
 begin
    SendMessage(Adata.MainWindow, CM_RESTOREPLUGINMEM, 0, longint(@Name[0]));
 end;

 case Schedule of
  0:{logon - no memory is allocated?}
  begin
   if logon then ChangeWallpaperNow;
  end;
  1:{day - set timer?}
  begin
   GetDateFormat(LOCALE_SYSTEM_DEFAULT,
                   0, nil, DateFormat, NewDate, sizeof(NewDate));
   if lstrcmp(Date, NewDate)<>0 then
    ChangeWallpaperNow;
  end;
   else
  begin{recycle - for fast comps}
   ChangeWallpaperNow;
  end;
 end;
end;


{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
begin
 Seed:= GetTickCount;
 RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
 if FindWindow('#32770', 'Master for Aston')<>0 then exit;
 if FindWindow('#32770', 'Theme Manager')<>0 then exit;
 if GlobalFindAtom(Name)<>0 then exit
                            else
  AName:=GlobalAddAtom(Name);
 ReadConfig;
end;

{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
procedure DoneModule; stdcall;
begin
 if AName<>0 then GlobalDeleteAtom(AName);
 AName:= 0;
end;

{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
function GetPluginInfo:PPluginInfo;stdcall;
begin
 PluginInfo.cbSize:=SizeOf(TPluginInfo);
 PluginInfo.szName:=Name;
 PluginInfo.szDescription:=Dsk;
 PluginInfo.szSection:=Name;
 PluginInfo.nKeyCount:=KeyCount;
 PluginInfo.Keys:=@WallKeys;
 WallKeys[1].res2:=integer(@vSchedule);
 WallKeys[2].res2:=integer(@vMethods);
 result:=@PluginInfo;
end;
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
{----------------------------------------------------------------}
exports
 InitGlobalModule,
 DoneModule,
 GetPluginInfo;

end.
