unit drawpng;

interface

(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006
*)


uses
  Windows;

const
  ALPHA_USE_MMX = 0;
  ALPHA_USE_GDI = 1;
  ALPHA_USE_MSIMG = 2;
  
  drawpngdll = 'drawpng.dll';

function ResetRenderer(nMode: integer): BOOL; cdecl; external drawpngdll name 'ResetRenderer';


procedure LoadPng(pstrFileName: Pchar; var BMP: BITMAPINFO; var pBits: PByte;
  var bAlpha: BOOL; var hDIB32: HBITMAP); cdecl; external drawpngdll name 'LoadPng';

procedure LoadPngMem(membuff: Pointer; mem_size:DWORD;var BMP: BITMAPINFO; var pBits: PByte;
  var bAlpha: BOOL; var hDIB32: HBITMAP); cdecl; external drawpngdll name 'LoadPngMem';


function CreateDIB32(hdc: HDC; width: integer; height: integer;
  var BMP: BITMAPINFO; var pBits: PByte): HBITMAP; cdecl; external
  drawpngdll name 'CreateDIB32';

procedure BlendDIB32(w: integer; h: integer; start: integer;
  addition: integer;  pDst: PBYTE;  PSrc: PBYTE); cdecl; external
  drawpngdll name 'BlendDIB32';

procedure PreAlpha(bwidth: integer; bheight: integer; pBits: PByte);
  cdecl; external drawpngdll name 'PreAlpha';


procedure AlphaBlt(hdcDest: HDC; nXOriginDest: integer; nYOriginDest: integer;
  nWidthDest: integer; nHeightDest: integer;
  hbmpSrc: HBITMAP; nXOriginSrc: integer; nWidthOrigin: integer; nHeightOrigin: integer;
  pSrcBits: PByte); cdecl; external drawpngdll name 'AlphaBlt';

implementation
end.