/* Gladiators Software, 1999-2006*/ 




#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:BarMon.def")
#pragma comment(linker,"/entry:DllMain")

#include <windows.h>
#include "../SDK/rtlmem.h"
#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
#include "../CPUMon/getcpuu.h"
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}


//----------------------------------------------------------------
//----------------------------------------------------------------
extern BYTE (*RealGetCPUusage)(void);
extern BOOL bInitialized;


static int xbmp[] = 
{
  0, 9, 13, 22, 31, 40, 49, 58, 67, 76, 85
};
#define szNAME "Taskbar cpu monitor 1.0c"

static char szCPU[] = "Taskbar CPU Monitor\x00";
#define TimerID 155
#define szAbout "CPU(s) usage monitor"
#define szBackCl "BackColor"
#define szCpuCl1 "CPUColor1"
#define szCpuCl2 "CPUColor2"
#define szElapse "Elapse"
#define szUseVXD "UseVXD"
#define szPos "Position"
#define szPriority "DockingPriority"
#define szDim "Dimension"
#define szBevel "Bevel"

static char* vPos[] = 
{
  "Left (Top)", "Right (Bottom)"
};
static char* vDim[] = 
{
  "Kb", "Mb", "%"
};
static char* vBevel[] = 
{
  "None", "Lowered", "Raised"
};
static int eBevel[] = 
{
  BDR_SUNKENOUTER, BDR_RAISEDINNER
};

static TKey CPUKeys[]
= 
{
  {
    szElapse, 
    KEY_INT_RANGE | KEY_NOTHEME, szElapse, 950, 
    200, 5000
  }, 
  {
    szCpuCl1, 
    KEY_COLOR, szCpuCl1, 0x00ff60, 
    0, 0
  }, 
  {
    szCpuCl2, 
    KEY_COLOR, szCpuCl2, 0x0060ff, 
    0, 0
  }, 
  {
    szBackCl, 
    KEY_COLOR, szBackCl, 0x000000, 
    0, 0
  }, 
  {
    szPos, 
    KEY_LIST, szPos, 1, 
    sizeof(vPos)/sizeof(PCHAR) - 1, (int)&vPos
  }, 
  {
    szDim, 
    KEY_LIST | KEY_NOTHEME, szDim, 0, 
    sizeof(vDim)/sizeof(PCHAR) - 1, (int)&vDim
  }, 
  {
    szPriority, 
    KEY_INT, szPriority, 1, 
    0, 0
  }, 
  {
    szBevel, 
    KEY_LIST, szBevel, 1, 
    sizeof(vBevel)/sizeof(PCHAR) - 1, (int)&vBevel
  }, 
  {
    szUseVXD, 
    KEY_BOOL | KEY_NOTHEME, "Use VXD driver", 1, 
    0, 0
  }
};

int Bevel;

int Dim;
int Color1;
int Color2;
int sR;
int sG;
int sB;
TPicture bmpnumb;
MEMORYSTATUS me;
int PriorityW;
int PosWindow;
TAstonData AData;
HWND hCPUWnd = 0;
BOOL bTimer = FALSE;
HBRUSH Brush = 0;
TPluginInfo PluginInfo;
RECT ClientRect;
BOOL bUseVXD;
BOOL IsShowTip;
TOOLINFO ti;
char szCpuHint[32];

#define szFormat "CPU: %2u%%"

int _Width;
int _Height;
BYTE biCPUuse;
BYTE biOld = 255;
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 

/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
void InitToolTip(void)
{
  IsShowTip = FALSE;
  ti.cbSize = sizeof(TOOLINFO);
  ti.uFlags = TTF_CENTERTIP;
  ti.hwnd = hCPUWnd;
  ti.uId = 1;
  CopyRect(&ti.rect, &ClientRect);
  InflateRect(&ti.rect, -1, -1);
  ti.hinst = hInstance;
  lstrcpy(szCpuHint, szCPU);
  ti.lpszText = &szCpuHint[0];
  SendMessage(AData.ToolTip, TTM_ADDTOOL, 0, ((LPARAM)(&ti)));
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
void UpdateTip(void)
{
  if (biOld != biCPUuse)
  {
    UINT u;
    u = biOld = biCPUuse;
    wvsprintf(szCpuHint, szFormat, (CHAR *)&u);
    SendMessage(AData.ToolTip, TTM_UPDATETIPTEXT, 0, ((LONG)(&ti)));
  };
};

/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
void PrintMem(HDC dc)
{
  
  static char* MemFormat = "%2i%%";
  
  HDC Old;
  RECT r;
  int l;
  int x;
  int y;
  int i;
  int k;
  char st[32+1];
  {
    GlobalMemoryStatus(&me);
    
    i = (me.dwAvailPhys/1024);
    if (Dim == 1)
    i = i/1024;
    if (Dim == 2)
    i = 100-me.dwMemoryLoad;
    wvsprintf(st, MemFormat, (CHAR *)&i);
    GetClientRect(hCPUWnd, &r);
    y = (r.bottom-9)/2;
    Old = SelectObject(AData.MemoryDC, bmpnumb.Handle);
    l = 0;
    for (i = 0; i < lstrlen(st); i++)
    {
      if ((st[i] >= '0')&& (st[i] <= '9'))
      {
        k = (((BYTE)(st[i]))-((BYTE)('0')));
        l = l+xbmp[k+1]-xbmp[k];
      };
    };
    l += 12;
    x = (_Width/2)-(l/2);
    
    for (i = 0; i < lstrlen(st); i++)
    {
      if ((st[i] >= '0')&& (st[i] <= '9'))
      {
        k = (((BYTE)(st[i]))-((BYTE)('0')));
        l = xbmp[k+1]-xbmp[k];
        SelectObject(AData.MemoryDC, bmpnumb.Mask);
        BitBlt(dc, x, y, l, 9, AData.MemoryDC, xbmp[k], 
        0, SRCAND);
        SelectObject(AData.MemoryDC, bmpnumb.Handle);
        BitBlt(dc, x, y, l, 9, AData.MemoryDC, xbmp[k], 
        0, SRCPAINT);
        x = x + l;
      };
    };
    switch (Dim)
    {
      case 0:/*Kb*/ 
      {
        k = 84;
        l = 12;
      };
      break;
      case 1:/*Mb*/ 
      {
        k = 97;
        l = 13;
      };
      break;
default:/*%*/ 
      {
        k = 110;
        l = 10;
      };
    };/*case*/ 
    SelectObject(AData.MemoryDC, bmpnumb.Mask);
    BitBlt(dc, x, y, l, 9, AData.MemoryDC, k, 
    0, SRCAND);
    SelectObject(AData.MemoryDC, bmpnumb.Handle);
    BitBlt(dc, x, y, l, 9, AData.MemoryDC, k, 
    0, SRCPAINT);
    SelectObject(AData.MemoryDC, Old);
  };
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
LONG WINAPI WindowProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
  
  HDC dc;
  PAINTSTRUCT ps;
  RECT r;
  HBRUSH OldBrush;
  int step;
  int i;
  HMENU Menu;
  char szSetup[MAX_PATH+1];
  int c;
  {
    LONG result;
    
    NotifyTip(AData.ToolTip, window, message, wParam, lParam);
    result = 0;
    switch (message)
    {
      case WM_ERASEBKGND:
      {
        FillRect(((HDC)(wParam)), &ClientRect, Brush);
        if (Bevel != 0)
          DrawEdge(((HDC)(wParam)), &ClientRect, eBevel[Bevel - 1], BF_RECT);
        result++;
        return result;
      };
      break;
      case WM_PAINT:
      {
        dc = BeginPaint(window, &ps);
        SetRect(&r, 1, 1, 2, _Height);
        c = Color1;
        step = (((biCPUuse)*_Width)/100);
        for (i = 1; i <= step; i++)
        {
          OldBrush = CreateSolidBrush(c);
          FillRect(dc, &r, OldBrush);
          ++r.left;
          ++r.right;
          c = c+sR+(sG << 8)+(sB << 16);
          DeleteObject(OldBrush);
        };
        PrintMem(dc);
        EndPaint(window, &ps);
        return result;
      };
      break;
      case WM_TIMER:
      {
        if (! bInitialized)
        {
          InitCPUMon(bUseVXD, AData.osver->dwPlatformId == VER_PLATFORM_WIN32_NT);
          return result;
        };
        biCPUuse = RealGetCPUusage();
        UpdateTip();
        InvalidateRect(window, NULL, TRUE);
        return result;
      };
      break;
      case WM_SIZE:
      {
        if (hCPUWnd != 0)
        {
          GetClientRect(hCPUWnd, &ClientRect);
          _Height = ClientRect.bottom - 1;
          InvalidateRect(hCPUWnd, NULL, TRUE);
          CopyRect(&ti.rect, &ClientRect);
          SendMessage(AData.ToolTip, TTM_NEWTOOLRECT, 0, ((LONG)(&ti)));
        };
        return result;
      };
      break;
      case WM_CONTEXTMENU:
      {
        SetFocus(window);
        Menu = CreatePopupMenu();
        AppendMenu(Menu, MF_STRING, 501, "&Properties");
        TrackPopupMenuEx(Menu, TPM_RIGHTBUTTON, LOWORD(lParam), HIWORD(lParam), window, NULL);
        DestroyMenu(Menu);
      };
      break;
      case WM_LBUTTONDBLCLK:
      {
        PostMessage(AData.MainWindow, CM_TIMEDATESETUP, 0, 0);
      };
      break;
      case WM_COMMAND:
      {
        switch (LOWORD(wParam))
        {
          case 501:
          {
            szSetup[0] = '/';
            lstrcpy(&szSetup[1], AData.Node->Path);
            SendMessage(AData.MainWindow, CM_SETUPASTON, 0, ((LONG)(&szSetup[0])));
          };
        };
        return result;
      };
      
      break;
      case WM_NOTIFY:
      {
        switch ((*(LPNMHDR)(lParam)).code)
        {
          case TTN_SHOW:
          {
            result = ((int)(SetWindowPos((*(LPNMHDR)(lParam)).hwndFrom, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE)));
            
            IsShowTip = TRUE;
          };
          break;
          case TTN_POP:
          {
            IsShowTip = FALSE;
          };
        };
        return result;
      };
    };
    result = DefWindowProc(window, message, wParam, lParam);
    return result;
  };
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
void ReadConfig(void)
{
  
  TCFG CFG;
  int iElapse;
  UINT Cl;
  {
    OpenCFGr(AData.PluginsCFG, &CFG);
    FindSection(szCPU, 0, &CFG);
    Cl = GetCFGHex(szBackCl, 0, &CFG);
    Brush = CreateSolidBrush(Cl);
    Color1 = GetCFGHex(szCpuCl1, 0x00ff60, &CFG);
    Color2 = GetCFGHex(szCpuCl2, 0x0060ff, &CFG);
    iElapse = GetCFGInt(szElapse, 950, &CFG);
    bUseVXD = GetCFGInt(szUseVXD, 1, &CFG) != 0;
    PosWindow = GetCFGInt(szPos, 1, &CFG);
    CheckInt(&PosWindow, 0, 1, 0);
    PriorityW = GetCFGInt(szPriority, 1, &CFG);
    CheckInt(&PriorityW, 0, 1000, 100);
    CheckInt(&iElapse, 250, 5000, 950);
    Dim = GetCFGInt(szDim, 0, &CFG);
    CheckInt(&Dim, 0, 2, 0);
    Bevel = GetCFGInt(szBevel, 1, &CFG);
    CheckInt(&Bevel, 0, 2, 1);
    
    CloseCFGr(&CFG);
    bTimer = SetTimer(hCPUWnd, TimerID, iElapse, NULL) != 0;
    sR = ((Color2 & 255)-(Color1 & 255))/_Width;
    sG = (((Color2 >> 8) & 255)-((Color1 >> 8) & 255))/_Width;
    sB = (((Color2 >> 16) & 255)-((Color1 >> 16) & 255))/_Width;
  };
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 

void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  
  WNDCLASS WindowClass;
  TDockInfo DockInfo;
  {
    if (AstonData->cbsize < sizeof(TAstonData))
    return;
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    
    WindowClass.style = CS_HREDRAW | CS_VREDRAW;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WindowProc;
    WindowClass.lpszClassName = szNAME;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    hCPUWnd = CreateWindowEx(0, szNAME, 
    NULL, 
    WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
    0, 
    0, 0, 0, AData.Taskbar, 
    0, 
    hInstance, NULL);
    
    if (hCPUWnd == 0)
    return;
    
    _Width = 66;
    AData.Node->Wnd = hCPUWnd;
    ReadConfig();
/*with (DockInfo)*/
    {
      DockInfo.Wnd = hCPUWnd;
      DockInfo.Parent = AData.Taskbar;
      SetRect(&DockInfo.rc_Client, 0, 0, _Width+2, AData.Ring1->ButtonHeight*AData.Ring1->BarSize);
      DockInfo.Align = PosWindow;
      DockInfo.Vert = FALSE;
      DockInfo.Flat = FALSE;
      DockInfo.Priority = PriorityW;
    };
    SendMessage(AData.MainWindow, CM_DOCK, 0, ((LONG)(&DockInfo)));
    GetClientRect(hCPUWnd, &ClientRect);
    _Height = ClientRect.bottom - 1;
    RtlZeroMemory(&bmpnumb, sizeof(bmpnumb));
    bmpnumb.Width = 120;
    bmpnumb.Height = 9;
    bmpnumb.Options = PIC_NOCACHE;
    bmpnumb.Handle = LoadImage(hInstance, ((char*)(1)), IMAGE_BITMAP, 0, 0, 0);
    MakeMask(&bmpnumb);
    bmpnumb.IconType = PICTURE_BMP;

    InitToolTip();
  };
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 

void WINAPI DoneModule(void)
{
  if (bTimer)
  {
    bTimer = FALSE;
    KillTimer(hCPUWnd, TimerID);
  };
  if (hCPUWnd != 0)
  {
    SendMessage(AData.ToolTip, TTM_DELTOOL, 0, ((LPARAM)(&ti)));

    DestroyWindow(hCPUWnd);
    hCPUWnd = 0;
    DoneCPUmon(AData.osver->dwPlatformId == VER_PLATFORM_WIN32_NT);
    if (Brush != 0)
    DeleteObject(Brush);
    Brush = 0;
    FreePicture(&bmpnumb);
    RtlZeroMemory(&bmpnumb, sizeof(bmpnumb));
  };
  UnregisterClass(szNAME, hInstance);
};
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
/*-------------------------------------------------------------------------------*/ 
PPluginInfo WINAPI GetPluginInfo(void)
{
  
  OSVERSIONINFO os;
  {
    PPluginInfo result;
    
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szCPU;
    PluginInfo.szDescription = szAbout;
    PluginInfo.szSection = szCPU;
    PluginInfo.nKeyCount = sizeof(CPUKeys)/sizeof(TKey);
    os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&os);
    if (os.dwPlatformId == VER_PLATFORM_WIN32_NT)
    --PluginInfo.nKeyCount;
    PluginInfo.Keys = (PKey)&CPUKeys;
    result = &PluginInfo;
    return result;
  };
};
/*-------------------------------------------------------------------------------*/ 

//pas2c32 warnings: 8
