/* Gladiators Software, 1999-2006*/ 


#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:Termin.def")
//#pragma comment(linker,"/entry:DllMain")


#include <windows.h>
#include "../SDK/rtlmem.h"

//#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
#include "proces.h"

HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
static char* szName = "Task Terminator 2";
#define CM_ICONMESSAGE (WM_USER+1)
static char* szhelp = "Quick Task Terminator 2.2c\x0D\x0A"\
" 1999-2003 Gladiators Software\x0D\x0A"\
"Warning!\x0D\x0A"\
"Be careful at termination of tasks!\x0D\x0A"\
"All unsaved data will are lost!\x0D\x0A"\
"You should only terminate the hung tasks.";



static char* szKillAll = "Force reboot";

static char* SeDebug = "SeDebugPrivilege";
static char* SeDown = "SeShutdownPrivilege";

TAstonData AData;
HWND ChildWindow = 0;
NOTIFYICONDATA ta;
BOOL Added = FALSE;
TPluginInfo PluginInfo;
DWORD time;
HICON hungico;
HICON sysico;
int mHeight;
int mCheck;
HFONT defMenuFont;
//----------------------------------------------------------------
BOOL (WINAPI *IsHungAppWindow)(HWND w) = NULL;
BOOL (WINAPI *IsHungThread)(DWORD t) = NULL;
FARPROC EndTask = NULL;
//----------------------------------------------------------------
//----------------------------------------------------------------
extern DWORD osinfo;
extern DWORD curid;
extern int pcount;
extern PProc plist;
//----------------------------------------------------------------
#define szIcon "Icon"
TPicture sm_ico = {0};
//----------------------------------------------------------------
void InitUndocFunc(void)
{
  
  HANDLE User;
  {
    User = GetModuleHandle("USER32.DLL");
    if (osinfo == VER_PLATFORM_WIN32_NT)
      IsHungAppWindow = (void *)GetProcAddress(User, "IsHungAppWindow");
    else
      IsHungThread = (void *)GetProcAddress(User, "IsHungThread");
    EndTask = (void *)GetProcAddress(User, "EndTask");
  };
};
//----------------------------------------------------
//----------------------------------------------------
__declspec(naked) void __fastcall TerminateTaskByWindow(HWND wnd, DWORD pid)
{//ECX,  EDX
  __asm
  {
      XOR      EAX, EAX
      CMP      osinfo, VER_PLATFORM_WIN32_NT
      JZ       __1
      PUSH     EAX
__1:
      PUSH     EAX
      PUSH     EDX//pid
      PUSH     ECX//wnd
      CALL     EndTask
      RET
  }
};
//------------------------------------------------------
BOOL BetterWnd(HWND wOld, HWND wNew)
{
  
  LONG exstylen;
  LONG exstyleo;
  {
    BOOL result;
    
    result = TRUE;
    if (wOld == 0)
    return result;
    if (IsWindowVisible(wNew))
    {
      if (!IsWindowVisible(wOld))
      return result;
      exstylen = GetWindowLong(wNew, GWL_EXSTYLE);
      if ((exstylen & WS_EX_TOOLWINDOW) == 0)
      {
        exstyleo = GetWindowLong(wOld, GWL_EXSTYLE);
        if ((exstyleo & WS_EX_TOOLWINDOW) != 0)
        return result;
        
        if (GetWindow(wNew, GW_OWNER) == 0)
        {
          if (GetWindow(wOld, GW_OWNER) != 0)
          return result;
        };
      };
    };
    result = FALSE;
    return result;
  };
};

//---------------
BOOL WINAPI EnumProc(HWND Wnd, LPARAM lParam)
{
  
  int i;
  DWORD id;
  {
    BOOL result;
    
    GetWindowThreadProcessId(Wnd, &id);
    for (i = 0; i < pcount; i++)
    {
      if (plist[i].pid == id)
      {
        if (BetterWnd(plist[i].wnd, Wnd))
        plist[i].wnd = Wnd;
        break;
      };
    };
    result = TRUE;
    return result;
  };
};
//----------------------------------------------------------------
//--------------------------------------------------------------------------------------------
void AddToMenu(HMENU Menu, int i, TProc* p)
{
  
  int j;
  int k;
  {
    if ((NULL != ((*p).szexe)) && ((*p).szexe[0] != 0))
    {
      j = FindNameInPath((*p).szexe);
      (*p).caption = malloc(MAX_PATH);
      lstrcpy((*p).caption, &(*p).szexe[j]);
      j = 0;
      while ((*p).caption[j] != '\x00')
      {
        ++j;
        if ((*p).caption[j] == '.')
        (*p).caption[j] = '\x00';
      };
      if ((*p).wnd != 0)
      {
        k = j;
        lstrcpy(&(*p).caption[j], " - ");
        j += 3;
        if (GetWindowText((*p).wnd, &(*p).caption[j], MAX_PATH-j-1) == 0)
        (*p).caption[k] = '\x00';
        
        if (IsHungAppWindow != NULL)
        {
          if (IsHungAppWindow((*p).wnd))
            (*p).flag |= FLAG_HUNG;
        }
        else
        if (IsHungThread != NULL)
        {
          if (IsHungThread(GetWindowThreadProcessId((*p).wnd, NULL)))
          (*p).flag |= FLAG_HUNG;
        }
      };
      
      AppendMenu(Menu, MF_OWNERDRAW, i, ((char*)(i)));
    };
  };
};
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
void GetMenuSize(void)
{
  
  NONCLIENTMETRICS NonClientMetrics;
  {
    RtlZeroMemory(&NonClientMetrics, sizeof(NonClientMetrics));
    NonClientMetrics.cbSize = sizeof(NonClientMetrics);
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, &NonClientMetrics, 0);
    mHeight = NonClientMetrics.iMenuHeight;
    mCheck = GetSystemMetrics(SM_CXMENUCHECK);
    CheckInt(&mCheck, 18, mCheck, 18);
    if (NonClientMetrics.lfMenuFont.lfCharSet == 0)
    NonClientMetrics.lfMenuFont.lfCharSet = DefCharSet();//???
    defMenuFont = CreateFontIndirect(&NonClientMetrics.lfMenuFont);
  };
};
//----------------------------------------------------------------
void AdjustPrivileges(char* pp)
{
  
  HANDLE hToken;
  TOKEN_PRIVILEGES tkp;
  {
    if (osinfo != VER_PLATFORM_WIN32_NT)
    return;
    if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
    return;
    LookupPrivilegeValue(NULL, pp, &tkp.Privileges[0].Luid);
    tkp.PrivilegeCount = 1;
    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
    AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, NULL, NULL);
    CloseHandle(hToken);
  };
};

//----------------------------------------------------------------
void ShowMenu(void)
{
  
  HMENU Menu;
  TPMPARAMS TP;
  POINT p;
  int i;
  UINT u;
  HANDLE hProcess;
  {
    if (GetTickCount()-time < 50)
    return;
    if (plist != NULL)
    return;
    GetProcessList();
    
    if (osinfo == VER_PLATFORM_WIN32_NT)
    FillProcessListNT();
    else
    FillProcessList9x();
    
    if (plist == NULL)
    return;
    
    EnumWindows(EnumProc, 0);
    
    Menu = CreatePopupMenu();
    AppendMenu(Menu, MF_OWNERDRAW, pcount + 1, ((char*)(pcount + 1)));
    AppendMenu(Menu, MF_SEPARATOR, 0, NULL);
    for (i = 0; i < pcount; i++)
    AddToMenu(Menu, i + 1, &plist[i]);
    
    
    SetForeWndFix(AData.Taskbar, AData.osver);
    SetFocus(ChildWindow);
    
    GetMenuSize();
    
    TP.cbSize = sizeof(TPMPARAMS);
    GetWindowRect(AData.Taskbar, &TP.rcExclude);
    
    GetCursorPos(&p);
#ifdef _DEBUG
    OutputDebugString("T2: EnterMenu\n");
#endif
    u = TrackPopupMenuEx(Menu, TPM_RIGHTBUTTON | TPM_RETURNCMD, p.x,  p.y, ChildWindow, &TP);
#ifdef _DEBUG
    OutputDebugString("T2: ExitMenu\n");
#endif
    DestroyMenu(Menu);
    PostMessage(ChildWindow, WM_NULL, 0, 0);
    
    DeleteObject(defMenuFont);
    
    TryFreeProcessList();
    
    if (u == 0)
    time = GetTickCount();
    else
    if (((int)(u) <= pcount) && ((int)(u) > 0))
    {
      u--;
      if ((plist[u].flag & FLAG_SYS) != 0)
      {
        PostMessage(AData.Desktop, WM_CLOSE, 0, 0);
      }
      else
      if (plist[u].pid == curid)
      {
//      PostMessage(AData.MainWindow, WM_CLOSE, 0, 0)
        SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);
        MessageBox(0, "I cannot self-terminate. ;-)", szName, MB_OK | MB_ICONSTOP | MB_TOPMOST);
        SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);
      }
      else
      if ((NULL != EndTask) && IsWindow(plist[u].wnd))
      {
        AdjustPrivileges(SeDebug);
        TerminateTaskByWindow(plist[u].wnd, plist[u].pid);
      }
      else
      {
        AdjustPrivileges(SeDebug);
        SetLastError(0);
        hProcess = OpenProcess(PROCESS_TERMINATE, FALSE, plist[u].pid);
        if (hProcess != 0)
        {
          TerminateProcess(hProcess, 0);
          CloseHandle(hProcess);
        }
        else
        {
          SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);
          ErrorBox(plist[u].caption);
          SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);
        };
      };
    }
    else
    {
      AdjustPrivileges(SeDown);
      ExitWindowsEx(EWX_REBOOT | EWX_FORCE, 0);
    };
    
    for (i = 0; i < pcount; i++)
    {
      free(plist[i].szexe);
      free(plist[i].caption);
    };
    free(plist);
    plist = NULL;
  };
};

// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
void OnMeasureItem(const PMEASUREITEMSTRUCT lpmis)
{
/*with ((*lpmis))*/
  if (lpmis->CtlType == ODT_MENU)
  {
    lpmis->itemWidth = 200-mCheck;
    lpmis->itemHeight = mHeight;
  };
};
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
void OnDrawMenuItem(const PDRAWITEMSTRUCT lpdis)
{
  
  COLORREF clrPrevText;
  HGDIOBJ Old;
  RECT r;
  int OldMode;
  HBRUSH Brush;
  char* szp;
  HICON ico;
  {
/*with ((*lpdis))*/
    if (lpdis->CtlType == ODT_MENU)
    {
      
      CopyRect(&r, &lpdis->rcItem);
      
      if ((lpdis->itemState & ODS_SELECTED) != 0)
      Brush = GetSysColorBrush(COLOR_HIGHLIGHT);
      else
      Brush = GetSysColorBrush(COLOR_MENU);
      
      FillRect(lpdis->hDC, &r, Brush);
      
      szp = szKillAll;
      if ((((int)(lpdis->itemData)) <= pcount) && (((int)(lpdis->itemData)) > 0))
      {
        PProc pro = &plist[lpdis->itemData - 1];
        ico = 0;
        if (((pro->flag) & FLAG_HUNG))
        ico = hungico;
        if (((pro->flag) & FLAG_SYS))
        ico = sysico;
        if (ico != 0)
        DrawIconEx(lpdis->hDC, r.left+1, (r.bottom+r.top-16) >> 1, ico, 0, 0, 0, Brush, DI_NORMAL);
        szp = pro->caption;
      };
      
      r.left += mCheck;
      
      Old = SelectObject(lpdis->hDC, defMenuFont);
      if ((lpdis->itemState & ODS_SELECTED) != 0)
      clrPrevText = SetTextColor(lpdis->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
      else
      clrPrevText = SetTextColor(lpdis->hDC, GetSysColor(COLOR_MENUTEXT));
      
      OldMode = SetBkMode(lpdis->hDC, TRANSPARENT);
      
      DrawText(lpdis->hDC, szp, -1, &r, DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOCLIP | DT_NOPREFIX);
      
      SetBkMode(lpdis->hDC, OldMode);
      SelectObject(lpdis->hDC, Old);
      SetTextColor(lpdis->hDC, clrPrevText);
    };
  };
};
//------------------------------------------
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
LONG WINAPI SDKWindowProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)

{
  LONG result;
  
  result = 0;
  switch (message)
  {
    case CM_ICONMESSAGE:
    {
      if ((lParam == WM_LBUTTONDOWN) || (lParam == WM_RBUTTONDOWN))
      ShowMenu();
      return result;
    };
    break;
    case WM_MEASUREITEM:
    {
      OnMeasureItem((PMEASUREITEMSTRUCT)(lParam));
      ++result;
      return result;
    };
    break;
    case WM_DRAWITEM:
    {
      OnDrawMenuItem((PDRAWITEMSTRUCT)(lParam));
      ++result;
      return result;
    };
  };
  result = DefWindowProc(window, message, wParam, lParam);
  return result;
};
//---------------------------------------------------------------------
//---------------------------------------------------------------------
void ReadConfig(void)
{
  TCFG CFG;
  OpenCFGr(AData.PluginsCFG, &CFG);
  FindSection(szName, 0, &CFG);
  GetCFGPic(szIcon, &sm_ico, &CFG);
  CloseCFGr(&CFG);
  sm_ico.Height = sm_ico.Width = AData.Ring1->TrayIconSize;
  sm_ico.Options |= ICO_USE_W_H;
  LoadImageEx(&sm_ico);
};
//---------------------------------------------------------------------
void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  WNDCLASS WindowClass;
//  ICONINFO info;
  HICON SmallIcon;
  {
#ifdef _DEBUG
    OutputDebugString("T2: Init\n");
#endif
    if (AstonData->cbsize < sizeof(TAstonData))
    return;
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    osinfo = AData.osver->dwPlatformId;
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = SDKWindowProc;
    WindowClass.lpszClassName = szName;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    InitUndocFunc();
    
    ChildWindow = CreateWindowEx(0, szName, NULL, WS_CHILD, 0, 
    0, 0, 0, AData.Taskbar, 0, hInstance, NULL);
    
    AData.Node->Wnd = ChildWindow;
    
    ReadConfig();
    SmallIcon = NULL;
    if (sm_ico.IconType == PICTURE_BMP)
    {
      HIMAGELIST him;
/*
      info.fIcon = TRUE;
      info.xHotspot = info.yHotspot = 0;
      info.hbmMask = sm_ico.Mask;
      info.hbmColor = sm_ico.Handle;
      SmallIcon = CreateIconIndirect(&info);
*/
      
      him = ImageList_Create(sm_ico.Width, sm_ico.Height, ILC_MASK | ILC_COLORDDB, 1, 0);
      if (NULL != him)
      {
        int i = ImageList_Add(him, sm_ico.Handle, sm_ico.Mask);
        if (-1 != i)
          SmallIcon = ImageList_GetIcon(him, i, ILD_TRANSPARENT);
        ImageList_Destroy(him);
      }
    }
    else
    if (sm_ico.IconType == PICTURE_SYSIMAGELIST)
      SmallIcon = ImageList_GetIcon(sm_ico.Handle, (int)sm_ico.Mask, ILD_TRANSPARENT);
    ta.cbSize = sizeof(ta);
    ta.hWnd = ChildWindow;
    ta.uID = 1;
    ta.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
    ta.uCallbackMessage = CM_ICONMESSAGE;
    ta.hIcon = SmallIcon;
    if (NULL == SmallIcon)
      ta.hIcon = LoadImage(hInstance, ((char*)(1)), IMAGE_ICON, 16, 16, LR_SHARED);
    lstrcpy(ta.szTip, szName);
    
    __asm
    {
      MOV EAX, offset ta
      CALL AData.AddTrayIcon
      MOV Added, EAX
    }
    if (NULL != SmallIcon)
      DestroyIcon(SmallIcon);

    hungico = LoadImage(hInstance, ((char*)(3)), IMAGE_ICON, 16, 16, LR_SHARED);
    sysico = LoadImage(hInstance, ((char*)(2)), IMAGE_ICON, 16, 16, LR_SHARED);
  };
#ifdef _DEBUG
    OutputDebugString("T2: Init: OK\n");
#endif
};
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
void WINAPI DoneModule(void)
{
#ifdef _DEBUG
    OutputDebugString("T2: Done\n");
#endif
  if (Added)
  __asm
  {
    MOV EAX, offset ta
    CALL AData.RemoveTrayIcon
  }
  Added = FALSE;
  if (ChildWindow != 0)
  {
    SendMessage(ChildWindow, WM_CANCELMODE, 0, 0);
    DestroyWindow(ChildWindow);
    ChildWindow = 0;
  };
  DoneProcessInfo();
  FreePicture(&sm_ico);
  RtlZeroMemory(&sm_ico, sizeof(sm_ico));
  UnregisterClass(szName, hInstance);
#ifdef _DEBUG
    OutputDebugString("T2: Done: OK\n");
#endif
};

static TKey T2Keys[] = 
{
  {
    szIcon, KEY_STATIC_ICON, szIcon, 0, 0, 0
  }
};
//---------------------------------------------------------------------
PPluginInfo WINAPI GetPluginInfo(void)
{
  PPluginInfo result;
  
  PluginInfo.cbSize = sizeof(TPluginInfo);
  PluginInfo.szName = szName;
  PluginInfo.szDescription = szhelp;
  PluginInfo.szSection = szName;
  PluginInfo.nKeyCount = sizeof(T2Keys)/sizeof(TKey);
  PluginInfo.Keys = (PKey)&T2Keys[0];
  result = &PluginInfo;
  return result;
};
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

//pas2c32 warnings: 6
