unit w2k;

interface

uses
  Windows,
  Messages;

const
  WS_EX_LAYERED =          $00080000;
  WS_EX_NOACTIVATE =       $08000000;
  LWA_COLORKEY  =          $00000001;
  LWA_ALPHA     =          $00000002;


  NIF_STATE       = $00000008;
  NIF_INFO        = $00000010;
  NIS_HIDDEN      = $00000001;
  NIS_SHAREDICON  = $00000002;
  _NIS_HIDDEN     = $01000000;

{ Notify Icon Infotip flags}
  NIIF_NONE       = $00000000;
{ icon flags are mutualy exclusive}
{ and take only the lowest 2 bits}
  NIIF_INFO       = $00000001;
  NIIF_WARNING    = $00000002;
  NIIF_ERROR      = $00000003;
{--------------------------------------------------------------------}
  SPI_GETMENUFADE = $1012;
  SPI_SETMENUFADE = $1013;

  WPSTYLE_CENTER      = 0;
  WPSTYLE_TILE        = 1;
  WPSTYLE_STRETCH     = 2;
  WPSTYLE_MAX         = 3;

const
  ICON_SMALL2         = 2;

type
 SetLayeredWindowAttributes = function(
    wnd:HWND;
    crKey:COLORREF;
    bAlpha: BYTE;
    dwFlags: DWORD): BOOL;stdcall;
 AllowSetForegroundWindow = function(
    dwProcessId:DWORD):BOOL;stdcall;


type
  PNOTIFYICONDATA5A = ^NOTIFYICONDATA5A;
  NOTIFYICONDATA5A = record
    cbSize: DWORD;
    Wnd: HWND;
    uID: UINT;
    uFlags: UINT;
    uCallbackMessage: UINT;
    hIcon: HICON;
    szTip:array[0..127] of char;
    dwState:DWORD;
    dwStateMask:DWORD;
    szInfo:array[0..255] of char;
    uTimeout:UINT;
    szInfoTitle:array[0..63] of char;
    dwInfoFlags:DWORD;
  end;
  PNOTIFYICONDATA5W = ^NOTIFYICONDATA5W;
  NOTIFYICONDATA5W = record
    cbSize: DWORD;
    Wnd: HWND;
    uID: UINT;
    uFlags: UINT;
    uCallbackMessage: UINT;
    hIcon: HICON;
    szTip:array[0..127] of Wchar;
    dwState:DWORD;
    dwStateMask:DWORD;
    szInfo:array[0..255] of Wchar;
    uTimeout:UINT;
    szInfoTitle:array[0..63] of Wchar;
    dwInfoFlags:DWORD;
  end;


  PNOTIFYICONDATAXP = ^NOTIFYICONDATAXP;
  NOTIFYICONDATAXP = packed record
    cbSize: DWORD;
    Wnd: HWND;
    uID: UINT;
    uFlags: UINT;
    uCallbackMessage: UINT;
    hIcon: HICON;
    szTip:array[0..127] of Wchar;
    dwState:DWORD;
    dwStateMask:DWORD;
    szInfo:array[0..255] of Wchar;
    uTimeout:UINT;
    szInfoTitle:array[0..63] of Wchar;
    dwInfoFlags:DWORD;
    reserved: TGUID;
  end;


implementation
end.
