//rtlmem.h

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef _RTLMEM_H_
#define _RTLMEM_H_

#ifdef __cplusplus
extern "C" {
#endif

#undef RtlZeroMemory

NTSYSAPI
VOID
NTAPI
RtlZeroMemory (
  VOID *Destination,
  SIZE_T Length
  );
//-----------------------------------------
#undef RtlFillMemory

NTSYSAPI
VOID
NTAPI
RtlFillMemory (
  VOID *Destination,
  SIZE_T Length,
  BYTE Fill
  );
//-----------------------------------------
#undef RtlMoveMemory

NTSYSAPI
VOID
NTAPI
RtlMoveMemory (
  VOID *Destination,
  CONST VOID *Source,
  SIZE_T Length
  );

#ifdef __cplusplus
}
#endif


#endif
